/* this is alpha beta only...seems to work */
#include "cbtypes.h"
#include "Ran.h"
#include <stream.h>
//#include "simclass.H"
#include <math.h> 
#include "AB.h"

/********************************
* this example runs AB filter on sine wave data that is
* interrupted for a while... filter keeps on with its
* constant velocity guess, then when data comes
* back on it adjusts.
* meant to be used with input file simin.ab
*********************************/


double Timex[300], Xx[300], X_est[300], Vel[300], Vel_est[300];
//this guy writes the "files" you want sequentially out on stdout.  Sorry!
// I break them up by hand and use gnuplot to look at them.

double  timestep;


main()

{
data_type mydata;
double Advance;
double t,  x, x_old, xvel;
double time, inp,running,k;
int verbose;
int j;
double plantnoise, measnoise;
double lambda;
double innov;
int initticks;
double timeoutsecs;

cout << "\n Welcome to the alpha beta simulator";

cout << "\n verbose?";
cin >>verbose;

cout << "\n give timestep and advance desired";

cin >> timestep;
cin >> Advance;
cout << "\n timestep = " << timestep << " and advance =" << Advance;

cout << "\n give running time";
cin >> running;
cout << form("\n running = %f: ", running);
 
int steps = irint(running/timestep);
cout << form("\n steps = %d: ", steps);

cout << "\n give init_ticks";
cin >> initticks;
cout << form("\n ticks = %d: ", initticks);

cout << "\n give timeout_secs";
cin >> timeoutsecs;
cout << form("\n timeoutsecs = %f: ", timeoutsecs);

cout << "\n Give velocity of target: ";
cin >> xvel;

//************this for sine wave and other auto velocities only!!!!
xvel = 0.0; //watch it! comment this s.o.b if you want const vel!! 
//************this for sine wave and other auto velocities only!!!!

cout << form("\n xvel = %f: ", xvel);

cout << "\n give plant noise std:";
cin >>plantnoise;
cout << "\n give measurement noise std:";
cin >> measnoise;
cout << form("\n plant and meas noise: %f %f", plantnoise, measnoise);

lambda = plantnoise/measnoise;
cout << form ("\n lambda = %f", lambda );

cout << form("\n  maneuverability index: %f",lambda);

cout << form("\n plant and meas noise: %f %f", plantnoise, measnoise);

normal n0(4227,0.0,plantnoise,1);
normal n1(999,0.0,measnoise,1);

double beta, term,  alpha;

// below is magic formula to compute alpha and beta coeffs given
// maneuverability coef, from Bar-Shalom and Fortman, assuming
// random uncertainties in velocity.
 
term = lambda*lambda + 8.0*lambda;
alpha = - (term -(lambda + 4.0)* sqrt(term)) / 8.0;
beta =  (lambda*lambda + 4.0*lambda - lambda* sqrt(term) )/4.0;

cout << "\n alpha and beta: " << alpha << " " << beta;

x = 0.0;

time = 0.0; 

filter_params f_parms;

f_parms.alpha = alpha;
f_parms.beta = beta;
f_parms.init_ticks = initticks;
f_parms.timeout_secs = timeoutsecs;
f_parms.time_step = timestep;


filter F(f_parms);

for (int i = 0; i <= steps; i++)
	{

	if (verbose) cout << "\n Time: " << time;
	inp = x + n1.sample();  // noisy reading of xpos


	if ((i>17) & (i<26)) mydata = nodata; else mydata = data;
	F.run(mydata,inp, Advance);

	if (verbose) F.dump();

// boring and ugly way to save data...should to fprintf...
	Timex[i] = time;
	Xx[i] = x;
	Vel[i] = xvel;
	X_est[i] = F.x_est;
	Vel_est[i] = F.v_est;

	time += timestep;
	xvel = sin(time) + n0.sample(); //  add plant noise.
// note here we just make up any old velocity.  To be fairer it should
// just be the target velocity plus the normal noise but we're torturing
// filter here.
	x +=  xvel*timestep; // move the target.

	}

	cout << form("\n#T versus X");

// boring and ugly way to save data...should to fprintf...
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Xx[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  est_X");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], X_est[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  Vel");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Vel[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  est_Vel");
for ( i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Vel_est[i]);
	}
}

