/* this is a-b-c filter I hope */

#include "cbtypes.h"
#include "Ran.h"
#include <stream.h>
//#include "simclass.H"
#include <math.h> 
#include "ABC.h"

/**********************
* see in-line comments in the alpha-beta version of this
* test driver...everything is parallel between the two..
**********************/

float Timex[300], Xx[300], X_est[300], Vel[300], Vel_est[300];
//float Init_pos[32], Init_vel[32], Init_acc[32];
float Acc_est[300], Acc[300];

main()

{
data_type mydata;
int i;
double timeoutsecs,timestep, advance;
double t,  x, x_old, xvel, xacc;
double a_est, a_future;
double x_obs, x_est, x_pred, x_future, v_est, v_pred, v_future;
double time, inp,running,k;
int initialized = 0;
int verbose;
int j;
double plantnoise, measnoise;
double actplantnoise, actmeasnoise;
double lambda;
double innov;

cout << "\n Welcome to the alpha beta gamma simulator";

cout << "\n verbose?";
cin >>verbose;

cout << "\n give timestep and advance desired";

cin >> timestep;
cin >> advance;

cout << "\n give running time";
cin >> running;
 
int steps = irint(running/timestep);

cout << "\n timestep = " << timestep << " and advance =" << advance;

cout << "\n Give Ticks for initialization:";
int initticks;
cin >>initticks;
cout << "\n give timeout_secs";
cin >> timeoutsecs;
cout << form("\n timeoutsecs = %f: ", timeoutsecs);

cout << "\n Give position of target: ";
cin >> x;
cout << "\n Give velocity of target: ";
cin >> xvel;
cout << "\n Give acceleration of target: ";
cin >> xacc;
cout << form("\n pos, vel, accel: %f %f %f",x, xvel,xacc);

cout << "\n give predicted  plant noise std:";
cin >>plantnoise;
cout << "\n give predicted measurement noise std:";
cin >> measnoise;
cout << form("\n plant and meas noise: %f %f", plantnoise, measnoise);

cout << "\n give actual  plant noise std:";
cin >>actplantnoise;
cout << "\n give actual measurement noise std:";
cin >> actmeasnoise;


lambda = plantnoise/measnoise;

cout << form("\n  maneuverability index: %f",lambda);

cout << form("\n plant and meas noise: %f %f", plantnoise, measnoise);

normal n0(4788,0.0,actplantnoise,1);
normal n1(11999,0.0,actmeasnoise,1);

double beta, term,  alpha, gamma;

term = lambda*lambda + 8.0*lambda;
alpha = - (term -(lambda + 4.0)* sqrt(term)) / 8.0;

beta =  (lambda*lambda + 4.0*lambda - lambda* sqrt(term) )/4.0;
gamma = (beta*beta)/alpha;

cout << "\n alpha, beta, gamma: " << alpha << " " << beta << " " << gamma;



// why - timestep?  that's a simulator thing but...
// time = -timestep;   

/***********************/
x = xvel = xacc = 0.0;
/***********************/

time = 0.0;

filter_params f_parms;

f_parms.alpha = alpha;
f_parms.beta = beta;
f_parms.gamma = gamma;
f_parms.init_ticks = initticks;
f_parms.timeout_secs = timeoutsecs;
f_parms.time_step = timestep;

abcfilter F(f_parms);

for (i = 0; i <= steps; i++)
	{

		if (verbose) cout << "\n Time: " << time;
		inp = x + n1.sample();  // noisy reading of xpos


		if ((i>18) & (i<22)) mydata = nodata; else mydata = data;
		F.run(mydata,inp, advance);

		if (verbose) F.dump();

		Timex[i] = time;
		Xx[i] = x;
		Vel[i] = xvel;
		Acc[i] = xacc;
		X_est[i] = F.x_est;
		Vel_est[i] = F.v_est;
		Acc_est[i] = F.a_est;

		time += timestep;
		xacc = sin(time) + n0.sample(); //  add plant noise.
		x +=  xvel*timestep +  0.5 * xacc*timestep*timestep; // move the target
		xvel +=  xacc*timestep; // move the target
		//xacc = xacc + n0.sample(); //  add plant noise.
	}



	cout << form("\n#T versus X");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Xx[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  est_X");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], X_est[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  Vel");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Vel[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  est_Vel");
for ( i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Vel_est[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  Acc");
for (i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Acc[i]);
	}

	cout << "\n";
	cout << form("\n#T versus  est_Acc");
for ( i = 0; i <= steps; i++)
	{
	cout << form("\n%f %f",Timex[i], Acc_est[i]);
	}
}
