#ifndef _filt_h
#define _filt_h

enum data_type {data, nodata};  // did we see a target or not?

enum filter_activity{invalid, initializing, tracking,predicting,timed_out};
// states filter gets into automatically while running so you can snooop on it

// below struct strictly for minimizing number of parameters in setting up filter

typedef struct filter_params{
        int seed; // for a "noisy" filter ...ignore
        double mean, stdev; // for a "noisy" filter ...ignore
        random_var* ranvar; // for a "noisy" filter ...ignore
	double time_step; 
        double timeout_secs;
        int init_ticks;
        double alpha, beta,gamma; 
	// do the below in the simulator, not in filter
        //double meas_noise, plant_noise;   //compute a,b,c offline, maybe global.
        //double maneuver_index;        // at any rate, don't offer this choice to user.
} *filter_params_t;
#endif
